#{extends 'cms/menu-tab-base.html' /}
<div class="card-header">
    Template Visualisasi
</div>
<div class="card-body">
    #{common.alert /}
    <div class="alert alert-danger alert-modal hidden"></div>
    <form action="" method="post" id="inputVisualisasiTableau" class="inputVisualisasiTableau">
        <input type="hidden" name="model.action" id="statusAction" value="${model.action}" >
        <input type="hidden" name="model.id" value="${model?.id}" >
        #{include 'cms/parts/kldi-selection.html' /}
        <div class="form-group has-feedback">
            <div class="row">
                <label for="title" class="col-2 control-label">Nama</label>
                <input type="text" name="model.title" id="title" required placeholder="Silahkan masukkan nama visualisasi" value="${model?.title}" class="col-12 form-control">
                <span class="form-control-feedback"></span>
                <span class="help-block">#{error 'model.title' /}</span>
            </div>
        </div>
        <div class="form-group has-feedback">
            <div class="row">
                <label for="model.libraryId" class="col-2 control-label">Library Tableau</label>
                <input type="hidden" id="tableau-url">
                <select class="col-12 form-control selectLibrary" required data-init-plugin="select2"  id="model.libraryId" name="model.libraryId" >
                    <option value="">Pilih salah satu Library visualisasi</option>
                    #{list libraries, as: 'item'}
                    <option value="${item.id}" ${model?.isItMyLibrary(item.id) ? 'selected' : ''}>${item.title}</option>
                    #{/list}
                </select>                                
                <span class="form-control-feedback"></span>
                <span class="help-block"><strong>#{error 'model.libraryId' /}</strong></span>
            </div>
        </div>
        <div class="form-group has-feedback">
            <div class="row">
                <label class="col-2 control-label param-label">Parameters</label>
            </div>
        </div>
        <div class="form-group has-feedback params-container">
        </div>
        <div class="form-group has-feedback">
            <div class="row">
                <label for="content" class="col control-label">Panduan Visualisasi</label>
                <div class="col-sm-12 #{errorClass 'model.content'/} summernote-wrapper">
                    <textarea class="form-control content" name="model.content" id="content" rows="10" cols="80">${model?.content}</textarea>
                </div>
                <span class="help-block content-error">#{error 'content' /}</span>
            </div>
        </div>
        #{include 'cms/parts/publishing-status.html' /}
        <div class="form-group has-feedback">
            <div class="row preview-tableau">
            </div>
        </div>
        <div class="form-group">
            <div class="row"style="justify-content:center;">
                <a href='' class="btn btn-success" id="save_button"><i class="fa fa-save"></i> Simpan</a>
                &nbsp;&nbsp;&nbsp;&nbsp;
                <a href='' class="btn btn-complete" id="preview_button"><i class="fs-14 fa fa-search"></i> Preview</a>
                &nbsp;&nbsp;&nbsp;&nbsp;
                <a href='@{index()}' class="btn btn-warning"><i class="fa fa-arrow-circle-left"></i> Kembali</a>
            </div>
        </div>
    </form>
</div>

#{set 'tabContentScripts'}
<script src="/public/javascripts/location-hash.js" type="text/javascript"></script>

<script>

$(document).ready(function() {
    
    let libraries = JSON.parse('${librariesJson.raw()}')
    let myLibrary = ${model?.libraryId ? model?.libraryId : 0};
    let queryParams = JSON.parse('${model?.getJsonParams().raw()}')
    let container = $('.params-container')
    let selectComponent = $('.selectLibrary')
    
    $('.preview-tableau').hide();
    $('#content').summernote({
        height: ($(window).height() - 400),
        placeholder: 'Silahkan masukkan panduan dalam membaca visualisasi',
        toolbar: [
            ['style', ['style']],
            ['font', ['bold', 'italic', 'underline', 'clear']],
            ['fontname', ['fontname']],
            ['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            ['table', ['table']],
            ['insert', ['link', 'picture', 'video']],
            ['view', ['fullscreen', 'codeview', 'help']],
        ],
        callbacks: {
            onImageUpload: function(image, editor, welEditable) {
                $('progress').attr('value','0.0');
                uploadImage(image[0], editor, welEditable);
            },
            onMediaDelete: function(image) {
                    deleteImage(image[0].src);
            },
            onChange: function(e) {
                removeErrorOnChange('.content-error')
            }
        }
    })
    baseValidationOptions.rules['model.libraryId'] = {
        required: true
    }
    baseValidationOptions.messages['model.libraryId'] = "Library tableau harus diisi!"
    
    $('#inputVisualisasiTableau').validate({
        rules: baseValidationOptions.rules,
        messages: baseValidationOptions.messages,
        errorElement: 'span',
        errorClass: 'help-block',
        focusInvalid: false,
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        success: function (label) {
            label.closest('.form-group').removeClass('has-error');
            label.remove();
        },
    });
    $('#preview_button').on('click',function(e) {
        e.preventDefault();
        
        if (!$('form.inputVisualisasiTableau').valid()) {
            return
        }
        $('.preview-tableau').height("630").show();
        var dataUrl = $('#tableau-url').val();
        let keys = [...$('input[name="model.paramKeys[]"]')].map(e => e.value)
        let values = [...$('select[name="model.paramValues[]"]')].map(e => e.value)
        var queryString = ''
        var glue = ''
        for (let i = 0; i < keys.length; i++) {
            queryString += glue + encodeURIComponent(keys[i]) + '=' + encodeURIComponent(values[i])
            glue = '&'
        }
        let kldiSelect = $('.kldi-select')
        let formData = new FormData()
        if (kldiSelect) {
            formData.append('kldi', kldiSelect.val() || '')
        }
        dataUrl = dataUrl + (dataUrl.includes('?') ? '&' : '?') + queryString
        formData.append('url', dataUrl)
        $.ajax({
            xhr: function() {
                var browser = navigator.appName;
                if(browser == "Microsoft Internet Explorer"){
                    var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                } else {
                    var xhr = new window.XMLHttpRequest();
                }
                xhr.upload.addEventListener("progress", function(evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = (evt.loaded / evt.total) * 100;
                }
                }, false);
                return xhr; },
            async:true,
            type: "POST",
            cache: false,
            data: formData,
            contentType: false,
            processData: false,
            url: "#{url route.cms_tokentableaucontroller_gettokentableau /}",
                beforeSend: function(){blockPreview();},
                success: function(result){
                    if (result.status) {
                        var iframe = document.createElement('iframe');
                        iframe.onload = function() {unblockPreview();};
                        iframe.src = result.url;
                        iframe.height = "600";
                        iframe.width = "800";
                        $('.preview-tableau').html('<label for="preview" class="col-2 control-label" style="vertical-align:top !important;">PREVIEW VISUALISASI</label>');
                        $('.preview-tableau').append(iframe);
                    } else {
                    $('.alert-modal')
                        .addClass('alert-danger')
                        .removeClass('alert-success')
                        .removeClass('hidden').html('&{translation.general_error}');
                    }
                },
            complete: function(){},
            error: function(){
                $('.alert-modal')
                    .addClass('alert-danger')
                    .removeClass('alert-success')
                    .removeClass('hidden').html('&{translation.general_error}');
            }
        });
    });

    $('#save_button').on('click', function(e) {
        e.preventDefault();
        
		if (!$('form.inputVisualisasiTableau').valid() || validateTextAreaWithSummer("#content")) {

            return
        }
        var data = new FormData($('#inputVisualisasiTableau')[0]);
        $('.alert-modal').addClass('hidden');
        $.ajax({
            xhr: function() {
                var browser = navigator.appName;
                if(browser == "Microsoft Internet Explorer"){
                var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                } else {
                var xhr = new window.XMLHttpRequest();
                }
                xhr.upload.addEventListener("progress", function(evt) {
                if (evt.lengthComputable) {
                    var percentComplete = (evt.loaded / evt.total) * 100;
                }
                }, false);
            return xhr; },
            async:true,
            type: "POST",
            cache: false,
            contentType: false,
            processData: false,
            url: "#{url route.cms_contentapicontroller_storevisualisasitableau /}",
            data: data,
                beforeSend: function(){blockPageUI();},
                success: function(result){
                    if (result.status){
                        $('.alert-modal').removeClass('hidden')
                                .removeClass('alert-danger')
                                .addClass('alert-success')
                                .html(result.message);
                        setDataAndChangeTab(result)
                    } else {
                        $('.alert-modal')
                            .addClass('alert-danger')
                            .removeClass('alert-success')
                            .removeClass('hidden').html(result.message);
                    }
                },
            complete: function(){unblockPageUI();},
            error: function(){
                $('.alert-modal')
                    .addClass('alert-danger')
                    .removeClass('alert-success')
                    .removeClass('hidden').html('&{translation.general_error}');
            }
        });
    
    });

    jQuery.extend(jQuery.validator.messages, {
        required: "Isian ini tidak boleh kosong",
        url: "Masukkan alamat url dengan benar. Gunakan awalan http:// atau https://",
    });

    if (myLibrary && myLibrary > 0) {
        printLibraryParameters(myLibrary)
    } else {
        readFromUrlAndSetSelected()
    }

    selectComponent.on('change.select2', function (e) {
        printLibraryParameters($(this).prop('value'))
    })

    function readFromUrlAndSetSelected() {
        let id = getLibFromLocation('lib')
        printLibraryParameters(id)
        if (id == 0) {
            return
        }
        selectComponent.val(id.toString()).trigger('change');
    }

    function printLibraryParameters(id) {
        let library = libraries.find(l => l.id == id)
        if (!library) {
            container.html('')
            return
        }
        var template = ''
        $('#tableau-url').val(library.url)
        updateLibOnLocation(library.id, 'lib')
        for (let param of library.params) {
            template += '<div class="row">' +
                '<input type="hidden" name="model.paramKeys[]" value="' + param.label + '">' +
                '<label class="col-md-6 control-label">' + param.label + '</label>'
            template += '<select class="col-md-12 form-control" required data-init-plugin="select2" name="model.paramValues[]" >'
            template += '<option value="">Pilih Nilai</option>'
            let selected = queryParams[param.label] ? queryParams[param.label] : ''
            let options = param.value.split(',')
            for (let option of options) {
                template += '<option value="' + option + '" '+ (selected === option ? 'selected' : '') + ' >' + option +'</option>'
            }
            template += '</select></div><br />'
        }
        container.html(template)
    }

});

</script>
#{/set}